=== debian/changelog ===
ausweisapp2 (1.26.1-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 20 Dec 2022 23:03:05 +0100

ausweisapp2 (1.26.0-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 18 Dec 2022 20:17:04 +0100
