=== resources/qml/CMakeLists.txt ===
if(IOS)
	add_library(AusweisAppQmlPlugins INTERFACE)
	qt_import_qml_plugins(AusweisAppQmlPlugins)
endif()
