=== debian/changelog ===
ausweisapp2 (1.26.2-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Mon, 23 Jan 2023 11:26:14 +0100
