## ausweisapp2 1.26.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,7 @@
 	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15 CACHE STRING "Required macOS version")
 endif()
 
-project(AusweisApp2 VERSION 1.26.2 LANGUAGES ${LANGUAGES})
+project(AusweisApp2 VERSION 1.26.3 LANGUAGES ${LANGUAGES})
 
 # Set TWEAK if not defined in PROJECT_VERSION above to
 # have a valid tweak version without propagating it
