=== debian/changelog ===
ausweisapp2 (1.26.3-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 12 Mar 2023 18:18:21 +0100
