=== debian/changelog ===
ausweisapp2 (1.26.5-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 01 Aug 2023 12:12:32 +0200

ausweisapp2 (1.26.5-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 27 Jul 2023 07:51:47 +0200

ausweisapp2 (1.26.4-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 11 May 2023 09:52:39 +0200
